/* Copyright (c) 2008 Kean Loong Tan http://www.gimiti.com/kltan
 * Licensed under the MIT (http://www.opensource.org/licenses/mit-license.php)
 * jFlow
 * Version: 1.2 (July 7, 2008)
 * Requires: jQuery 1.2+
 */
 
(function($) {

	$.fn.jFlow = function(options) {
		var opts = $.extend({}, $.fn.jFlow.defaults, options);
		var randNum = Math.floor(Math.random()*11);
		var jFC = opts.controller;
		var jFS =  opts.slideWrapper;
		var jSel = opts.selectedWrapper;

		var cur = 0;
		var maxi = $(jFC).length;
		$('#prevNext').append('<a href="#" class="play_pause">click to pause slideshow</a>');
		$('#prevNext').append('<div class="timer"></div>');
		// sliding function
		var slide = function (dur, i) {
			$(opts.slides).children().css({
				overflow:"hidden"
			});
			$(opts.slides + " iframe").hide().addClass("temp_hide");
			$(".overlay").css({zIndex:900});
				$('.jFlowPrev').animate({
					left : '10px'
				});
				$('.jFlowNext').animate({
					right : '10px'
				});
			$(opts.slides).animate({
				marginLeft: "-" + (i * $(opts.slides).find(":first-child").width() + "px")}, 
				opts.duration*(dur),
				opts.easing,
				function(){
					$(opts.slides).children().css({
						overflow:"hidden"
					});
					$(".temp_hide").show();
					$(".overlay").css({zIndex:0});
					$('.jFlowPrev').animate({
						left : '-25px'
					});
					$('.jFlowNext').animate({
						right : '-25px'
					});
				}
			);

			if($('.slider-two')){
				height = $('.slider-two').height();
				$('.slider-two .inner').animate({
				  marginTop : "-" + (i * height + "px")
				}, 500);
			}

		}
		$(this).find(jFC).each(function(i){
			$(this).click(function(){
				if ($(opts.slides).is(":not(:animated)")) {
					$(jFC).removeClass(jSel);
					$(this).addClass(jSel);
					var dur = Math.abs(cur-i);
					slide(dur,i);
					cur = i;
				}
			});
		});	
		
		$(opts.slides).before('<div id="'+jFS.substring(1, jFS.length)+'"></div>').appendTo(jFS);
		
		$(opts.slides).find("div.slidecontainer").each(function(){
			$(this).before('<div class="jFlowSlideContainer"></div>').appendTo($(this).prev());
		});
		
		//initialize the controller
		$(jFC).eq(cur).addClass(jSel);
		
		var resize = function (x){
			$(jFS).css({
				position:"relative",
				width: opts.width,
				height: opts.height,
				overflow: "hidden"
			});
			if($(window).width()>=1070){
				$('#side-bg').addClass('overlay');
				$('#prevNext,.paused,.play-pause').show();
			}else{
				$('#side-bg').removeClass('overlay');
				$('#prevNext,.paused,.play-pause').hide();
			}
			//opts.slides or #mySlides container
			$(opts.slides).css({
				position:"relative",
				width: $(jFS).width()*$(jFC).length+"px",
				height: $(jFS).height()+"px",
				overflow: "hidden"
			});
			// jFlowSlideContainer
			$(opts.slides).children().css({
				position:"relative",
				width: $(jFS).width()+"px",
				height: $(jFS).height()+"px",
				"float":"left",
				overflow:"hidden"
			});
			
			$(opts.slides).css({
				marginLeft: "-" + (cur * $(opts.slides).find(":eq(0)").width() + "px")
			});
		}
		
		// sets initial size
		resize();

		// resets size
		$(window).resize(function(){
			resize();						  
		});
		
	  var timer = function(){
			if(!paused){
				if($(window).width()>=1070){
					$('.timer').stop().css({
					width : '0'
					}).animate({
						width: '30px'
					}, opts.pauseLength);
				}
			}
	  }
	  
    var autoSlider = setInterval('$(".jFlowNext").click()',opts.pauseLength);
		timer();
		
	  var resetAutoSlider = function(){
		  clearInterval(autoSlider);
		  autoSlider = setInterval('$(".jFlowNext").click()',opts.pauseLength);
			timer();
		}
		
		var paused = 0;
		
		var pauseSlider = function(){
			clearInterval(autoSlider);
			paused = 1;
			$('.play_pause').html('slideshow paused - click to resume').addClass('paused');
			$('.timer').css({width:'0'}).stop();
		}

    var unpauseSlider = function(){
			resetAutoSlider();
			paused = 0;
			$('.play_pause').html('click to pause slideshow').removeClass('paused');
			timer();
		}
		
		$('.play_pause').click(function(e){
		  if(paused==1)
			  unpauseSlider();
		  else
			  pauseSlider();
			e.preventDefault();
		});

		$(opts.prev).click(function(e){
			if ($(opts.slides).is(":not(:animated)")) {
				var dur = 1;
				if (cur > 0)
					cur--;
				else {
					cur = maxi -1;
					dur = cur;
				}
				$(jFC).removeClass(jSel);
				slide(dur,cur);
				$(jFC).eq(cur).addClass(jSel);
			}
			resetAutoSlider();
			e.preventDefault();
		});
		
		$(opts.next).click(function(e){
			if ($(opts.slides).is(":not(:animated)")) {
				var dur = 1;
				if (cur < maxi - 1)
					cur++;
				else {
					cur = 0;
					dur = maxi -1;
				}
				$(jFC).removeClass(jSel);
				slide(dur, cur);
				$(jFC).eq(cur).addClass(jSel);
			}
  		resetAutoSlider();
			e.preventDefault();
		});
		
		$('.gobible-voyager a').click(function(e){
			if ($(opts.slides).is(":not(:animated)")) {
				var dur = 1;
				cur = 0;
				$(jFC).removeClass(jSel);
				slide(dur, cur);
				$(jFC).eq(cur).addClass(jSel);
			}
  		resetAutoSlider();
			e.preventDefault();
		});
		
		$('.original-gobible a').click(function(e){
			if ($(opts.slides).is(":not(:animated)")) {
				var dur = 1;
				cur = 1;
				$(jFC).removeClass(jSel);
				slide(dur, cur);
				$(jFC).eq(cur).addClass(jSel);
			}
  		resetAutoSlider();
			e.preventDefault();
		});
				
		$('.gobible-traveler a').click(function(e){
			if ($(opts.slides).is(":not(:animated)")) {
				var dur = 1;
				cur = 2;
				$(jFC).removeClass(jSel);
				slide(dur, cur);
				$(jFC).eq(cur).addClass(jSel);
			}
  		resetAutoSlider();
			e.preventDefault();
		});
		
		$('.gobible-downloads a').click(function(e){
			if ($(opts.slides).is(":not(:animated)")) {
				var dur = 1;
				cur = 3;
				$(jFC).removeClass(jSel);
				slide(dur, cur);
				$(jFC).eq(cur).addClass(jSel);
			}
  		resetAutoSlider();
			e.preventDefault();
		});
				
	};
	
	$.fn.jFlow.defaults = {
		controller: ".jFlowControl", // must be class, use . sign
		slideWrapper : "#jFlowSlide", // must be id, use # sign
		selectedWrapper: "jFlowSelected",  // just pure text, no sign
		easing: "swing",
		duration: 1700,
		pauseLength: 17000,
		width: "100%",
		prev: ".jFlowPrev", // must be class, use . sign
		next: ".jFlowNext" // must be class, use . sign
	};
	
})(jQuery);
